<template>
    <div class="page-container">
        <div class="log-title">
            Logs
            <div class="logs-button-container">
                <button
                    class="btn blue-btn"
                    @click="clearLogs"
                >
                    Clear Logs
                </button>
                <button
                    class="btn green-btn"
                    @click="testLogs"
                >
                    Test Logs
                </button>
            </div>
        </div>
        <div
            v-if="logs"
            class="table-responsive"
        >
            <table
                class="table-hover"
            >
                <thead class="table-header">
                    <tr>
                        <th>Record datetime</th>
                        <th>Level</th>
                        <th>Message</th>
                        <th>Channel</th>
                        <th>Context</th>
                        <th>Remote addr</th>
                        <th>User agent</th>
                    </tr>
                </thead>
                <tbody class="table-body">
                    <tr
                        v-for="(raw, index) in logs.data"
                        :key="index"
                        class="table-body-row"
                    >
                        <th>{{ raw.record_datetime }}</th>
                        <th>{{ raw.level_name }}</th>
                        <th>{{ raw.message }}</th>
                        <th>{{ raw.channel }}</th>
                        <th>
                            <button
                                id="show-modal"
                                @click="showModal(raw.context)"
                            >
                                Show details
                            </button>
                        </th>
                        <th>{{ raw.remote_addr }}</th>
                        <th>{{ raw.user_agent }}</th>
                    </tr>
                </tbody>
            </table>
            <pagination
                :data="logs"
                @pagination-change-page="loadLogs"
            />
        </div>
        <b-modal id="modal-sm" size="xl" title="Error context" v-model="modalShow" scrollable>
            <div class="modal-body" v-html="withBrTags(context)">
            </div>
        </b-modal>
    </div>
</template>

<script>
import logs from '../../mixins/admin/logs.service'

export default {
    name: "Logs",
    mixins: [logs],
    data() {
        return {
            modalShow: false,
            context: '',
            logs: null,
        }
    },
    created() {
        this.loadLogs()
    },
    methods: {
        withBrTags(text) {
            return text.replace(/(?:\r\n|\r|\n)/g, '<br />');
        },
        async loadLogs(page=1) {
            await this.getLogs(page).then(res => {
                this.logs = res.data
            })
        },
        async clearLogs() {
            await this.clear().then(res => {
                this.loadLogs();
                this.$notify({
                    type: 'success',
                    title: res.data.message
                });
            })
        },
        async testLogs() {
            await this.test().then(res => {
                this.loadLogs();
                this.$notify({
                    type: 'success',
                    title: 'Logs work!'
                });
            })
        },
        showModal(context){
            this.modalShow = !this.modalShow;
            this.context = context;
        }
    }
}
</script>

<style scoped lang="scss">
@import "resources/css/colors";

.page-container {
    padding-top: 40px;
}

.green-btn {
    background-color: $green;
    color: white;
    border-color: $green;
    padding: 10px 20px;
    font-weight: bold;
    border-radius: 5px;
    font-size: 14px;
    &:hover {
        background: #5cb85c;
        border-color: #5cb85c;
        color: white;
        text-decoration: none;
    }
}

.log-title {
    display: flex;
    justify-content: space-between;
    font-size: 28px;
    color: $blue-color;
    margin-bottom: 30px;
}

</style>
